package testxa;

import java.util.List;
import java.util.logging.Level;
import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.transaction.UserTransaction;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.PersistenceContext;
import javax.transaction.Status;
import javax.transaction.UserTransaction;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;

/**
 * Facade for entity Test.
 * 
 * @see testsql.Test
 * @author MyEclipse Persistence Tools
 */
//@Stateless
public class TestFacade implements TestFacadeRemote {
	// property constants
	public static final String TESTCOL = "testcol";

//	@PersistenceUnit
//	private EntityManager entityManager;
	private EntityManagerFactory entityManagerfct = Persistence.createEntityManagerFactory("TestXa");
	private EntityManager entityManager = entityManagerfct.createEntityManager();
	
	
	 //@PersistenceContext
	  //@Inject
	  //  private EntityManager entityManager;

//	    // Inject a UserTransaction for manual transaction demarcation.
//	    @Inject
//	    private UserTransaction userTransaction;
//
//	    // Inject a utility class for updating JPA entities
//	    @Inject
//	    private UnManagedComponent helper;


	/**
	 * Perform an initial save of a previously unsaved Test entity. All
	 * subsequent persist actions of this entity should use the #update()
	 * method.
	 * 
	 * @param entity
	 *            Test entity to persist
	 * @throws RuntimeException
	 *             when the operation fails
	 */
	public void save(Test entity) {
		LogUtil.log("saving Test instance", Level.INFO, null);
		try {
			entityManager.persist(entity);
			LogUtil.log("save successful", Level.INFO, null);
		} catch (RuntimeException re) {
			LogUtil.log("save failed", Level.SEVERE, re);
			throw re;
		}
	}

	/**
	 * Delete a persistent Test entity.
	 * 
	 * @param entity
	 *            Test entity to delete
	 * @throws RuntimeException
	 *             when the operation fails
	 */
	public void delete(Test entity) {
		LogUtil.log("deleting Test instance", Level.INFO, null);
		try {
			entity = entityManager.getReference(Test.class, entity.getIdtest());
			entityManager.remove(entity);
			LogUtil.log("delete successful", Level.INFO, null);
		} catch (RuntimeException re) {
			LogUtil.log("delete failed", Level.SEVERE, re);
			throw re;
		}
	}

	/**
	 * Persist a previously saved Test entity and return it or a copy of it to
	 * the sender. A copy of the Test entity parameter is returned when the JPA
	 * persistence mechanism has not previously been tracking the updated
	 * entity.
	 * 
	 * @param entity
	 *            Test entity to update
	 * @return Test the persisted Test entity instance, may not be the same
	 * @throws RuntimeException
	 *             if the operation fails
	 */
	public Test update(Test entity) {
		LogUtil.log("updating Test instance", Level.INFO, null);
		try {
			Test result = entityManager.merge(entity);
			LogUtil.log("update successful", Level.INFO, null);
			return result;
		} catch (RuntimeException re) {
			LogUtil.log("update failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Test findById(Integer id) {
		LogUtil.log("finding Test instance with id: " + id, Level.INFO, null);
		try {
			Test instance = entityManager.find(Test.class, id);
			return instance;
		} catch (RuntimeException re) {
			LogUtil.log("find failed", Level.SEVERE, re);
			throw re;
		}
	}

	/**
	 * Find all Test entities with a specific property value.
	 * 
	 * @param propertyName
	 *            the name of the Test property to query
	 * @param value
	 *            the property value to match
	 * @param rowStartIdxAndCount
	 *            Optional int varargs. rowStartIdxAndCount[0] specifies the the
	 *            row index in the query result-set to begin collecting the
	 *            results. rowStartIdxAndCount[1] specifies the the maximum
	 *            number of results to return.
	 * @return List<Test> found by query
	 */
	@SuppressWarnings("unchecked")
	public List<Test> findByProperty(String propertyName, final Object value,
			final int... rowStartIdxAndCount) {
		LogUtil.log("finding Test instance with property: " + propertyName
				+ ", value: " + value, Level.INFO, null);
		try {
			final String queryString = "select model from Test model where model."
					+ propertyName + "= :propertyValue";
			Query query = entityManager.createQuery(queryString);
			query.setParameter("propertyValue", value);
			if (rowStartIdxAndCount != null && rowStartIdxAndCount.length > 0) {
				int rowStartIdx = Math.max(0, rowStartIdxAndCount[0]);
				if (rowStartIdx > 0) {
					query.setFirstResult(rowStartIdx);
				}

				if (rowStartIdxAndCount.length > 1) {
					int rowCount = Math.max(0, rowStartIdxAndCount[1]);
					if (rowCount > 0) {
						query.setMaxResults(rowCount);
					}
				}
			}
			return query.getResultList();
		} catch (RuntimeException re) {
			LogUtil.log("find by property name failed", Level.SEVERE, re);
			throw re;
		}
	}

	public List<Test> findByTestcol(Object testcol, int... rowStartIdxAndCount) {
		return findByProperty(TESTCOL, testcol, rowStartIdxAndCount);
	}

	/**
	 * Find all Test entities.
	 * 
	 * @param rowStartIdxAndCount
	 *            Optional int varargs. rowStartIdxAndCount[0] specifies the the
	 *            row index in the query result-set to begin collecting the
	 *            results. rowStartIdxAndCount[1] specifies the the maximum
	 *            count of results to return.
	 * @return List<Test> all Test entities
	 */
	@SuppressWarnings("unchecked")
	public List<Test> findAll(final int... rowStartIdxAndCount) {
		LogUtil.log("finding all Test instances", Level.INFO, null);
		try {
			Query query = null;
			final String queryString = "select model from Test model";
			if(entityManager != null){
				 query = entityManager.createQuery(queryString);
			}
			else{
				System.err.println(" entityManager == null");
				return null;
			}
			if (rowStartIdxAndCount != null && rowStartIdxAndCount.length > 0) {
				int rowStartIdx = Math.max(0, rowStartIdxAndCount[0]);
				if (rowStartIdx > 0) {
					query.setFirstResult(rowStartIdx);
				}

				if (rowStartIdxAndCount.length > 1) {
					int rowCount = Math.max(0, rowStartIdxAndCount[1]);
					if (rowCount > 0) {
						query.setMaxResults(rowCount);
					}
				}
			}
			return query.getResultList();
		} catch (RuntimeException re) {
			LogUtil.log("find all failed", Level.SEVERE, re);
			throw re;
		}
	}

}