package testxa;

import java.util.List;
import javax.ejb.Remote;

/**
 * Remote interface for TestFacade.
 * 
 * @author MyEclipse Persistence Tools
 */
//@Remote
public interface TestFacadeRemote {
	/**
	 * Perform an initial save of a previously unsaved Test entity. All
	 * subsequent persist actions of this entity should use the #update()
	 * method.
	 * 
	 * @param entity
	 *            Test entity to persist
	 * @throws RuntimeException
	 *             when the operation fails
	 */
	public void save(Test entity);

	/**
	 * Delete a persistent Test entity.
	 * 
	 * @param entity
	 *            Test entity to delete
	 * @throws RuntimeException
	 *             when the operation fails
	 */
	public void delete(Test entity);

	/**
	 * Persist a previously saved Test entity and return it or a copy of it to
	 * the sender. A copy of the Test entity parameter is returned when the JPA
	 * persistence mechanism has not previously been tracking the updated
	 * entity.
	 * 
	 * @param entity
	 *            Test entity to update
	 * @return Test the persisted Test entity instance, may not be the same
	 * @throws RuntimeException
	 *             if the operation fails
	 */
	public Test update(Test entity);

	public Test findById(Integer id);

	/**
	 * Find all Test entities with a specific property value.
	 * 
	 * @param propertyName
	 *            the name of the Test property to query
	 * @param value
	 *            the property value to match
	 * @param rowStartIdxAndCount
	 *            Optional int varargs. rowStartIdxAndCount[0] specifies the the
	 *            row index in the query result-set to begin collecting the
	 *            results. rowStartIdxAndCount[1] specifies the the maximum
	 *            count of results to return.
	 * @return List<Test> found by query
	 */
	public List<Test> findByProperty(String propertyName, Object value,
			int... rowStartIdxAndCount);

	public List<Test> findByTestcol(Object testcol, int... rowStartIdxAndCount);

	/**
	 * Find all Test entities.
	 * 
	 * @param rowStartIdxAndCount
	 *            Optional int varargs. rowStartIdxAndCount[0] specifies the the
	 *            row index in the query result-set to begin collecting the
	 *            results. rowStartIdxAndCount[1] specifies the the maximum
	 *            count of results to return.
	 * @return List<Test> all Test entities
	 */
	public List<Test> findAll(int... rowStartIdxAndCount);
}